var heightUnit = "m"
var speedUnit = "m/s"
var level = ['无浪', '微浪', '小浪', '轻浪', '中浪', '大浪', '巨浪', '狂浪', '狂涛', '怒涛'];

function setUnit(hunit, speedunit) {
    heightUnit = hunit;
    speedUnit = speedunit;
}

function convertHeight(height) {

    if (heightUnit == "ft") {
        height = height * 0.3048;
        ;

    }
    return height.toFixed(0) + "" + heightUnit

}

function convertHeight1(height) {

    if (heightUnit == "ft") {
        height = height * 0.3048;
        ;

    }
    return height.toFixed(2) + "" + heightUnit

}

function convertWave(height) {
    if (heightUnit == "ft") {
        height = height * 0.3048;
    }
    return height.toFixed(2) + "" + heightUnit
}
function waveLevel(l){
    var levelStr = ''
    if (l) {
        if (l > 9) l = 9
        // levelStr = ' (' + level[Math.floor(l)] + "Level " + Math.floor(l) + ")"
        levelStr = Math.floor(l)+"级 ("+level[Math.floor(l)]+")"
    }
    return  levelStr
}
function getWindDirName(dir,language) {
    var d=dir;

    if (d >= 67.5 && d < 112.5) {
        return /zh/.test(language)?"东风":"East"
    } else if (d >= 112.5 && d < 157.5) {
        return /zh/.test(language)?"东南风":"Southeast"
    } else if (d >= 157.5 && d < 202.5) {
        return /zh/.test(language)?"南风":"South"
    } else if (d >= 202.5 && d < 247.5) {
        return /zh/.test(language)?"西南风":"Southwest"
    } else if (d >= 247.5 && d < 292.5) {
        return /zh/.test(language)?"西风":"West"
    } else if (d >= 292.5 && d < 337.5) {
        return /zh/.test(language)?"西北风":"Northwest"
    } else if (d >= 337.5 || d < 22.5) {
        return /zh/.test(language)?"北风":"North"
    } else if (d >= 22.5 && d < 67.5) {
        return /zh/.test(language)?"东北风":"Northeast"
    }else{
        return /zh/.test(language)?"东风":"East"
    }
}
function getWaveDirName(dir,language) {
    var d=dir;

    if (d >= 67.5 && d < 112.5) {
        return /zh/.test(language)?"东":"East"
    } else if (d >= 112.5 && d < 157.5) {
        return /zh/.test(language)?"东南":"Southeast"
    } else if (d >= 157.5 && d < 202.5) {
        return /zh/.test(language)?"南":"South"
    } else if (d >= 202.5 && d < 247.5) {
        return /zh/.test(language)?"西南":"Southwest"
    } else if (d >= 247.5 && d < 292.5) {
        return /zh/.test(language)?"西":"West"
    } else if (d >= 292.5 && d < 337.5) {
        return /zh/.test(language)?"西北":"Northwest"
    } else if (d >= 337.5 || d < 22.5) {
        return /zh/.test(language)?"北":"North"
    } else if (d >= 22.5 && d < 67.5) {
        return /zh/.test(language)?"东北":"Northeast"
    }else{
        return /zh/.test(language)?"东":"East"
    }
}
function getDirName(dir,language) {
    var d=dir;

    if (d >= 67.5 && d < 112.5) {
        return /zh/.test(language)?"西":"West"
    } else if (d >= 112.5 && d < 157.5) {
        return /zh/.test(language)?"西北":"Northwest"
    } else if (d >= 157.5 && d < 202.5) {
        return /zh/.test(language)?"北":"North"
    } else if (d >= 202.5 && d < 247.5) {
        return /zh/.test(language)?"东北":"Northeast"
    } else if (d >= 247.5 && d < 292.5) {
        return /zh/.test(language)?"东":"East"
    } else if (d >= 292.5 && d < 337.5) {
        return /zh/.test(language)?"东南":"Southeast"
    } else if (d >= 337.5 || d < 22.5) {
        return /zh/.test(language)?"南":"South"
    } else if (d >= 22.5 && d < 67.5) {
        return /zh/.test(language)?"西南":"Southwest"
    }else{
        return /zh/.test(language)?"西":"West"
    }
}
function convertSpeed(speed) {
    switch (speedUnit) {
        case "m/s":
            break;
        case "kt":
            speed = speed / 1852 * 3600;
            break;
        case "km/h":
            speed = speed * 3.6;
            break;
        case "mph":
            speed = speed / 1609.344 * 3600;
            break;
    }
    return speed.toFixed(2) + "" + speedUnit
}